CREATE DEFINER=`root`@`localhost` PROCEDURE `omplir_ingressos`()
BEGIN
	DECLARE done1 INT DEFAULT 0;
    DECLARE done2 INT DEFAULT 0;
	DECLARE naixement, debtor, registre DATE;
    DECLARE num_membre, id_temps, edat INT;
    DECLARE temps_c double;
    DECLARE quota_padel, quota_tennis, quota_trainer CHAR(1);
    DECLARE club, codi_quota VARCHAR(255);
    DECLARE preu DECIMAL(5,2);
	
    DECLARE cursor_membres 
		CURSOR FOR SELECT MembreId, Club_name, Registration_data, Birth_date, Monthly_tennis_fee, Monthly_padel_fee, Monthly_personal_trainer_fee, Since_when_is_debtor
			FROM membres;
	
	DECLARE cursor_temps
		CURSOR FOR SELECT TempsId, TempsComplet
			FROM temps
				WHERE Dia IS NULL;

                
	DECLARE CONTINUE HANDLER 
        FOR NOT FOUND SET done1 = 1;   
        

	OPEN cursor_membres;
    
    bucle_membres: LOOP
    
		FETCH cursor_membres 
			INTO  num_membre, club, registre, naixement, quota_tennis, quota_padel, quota_trainer, debtor;
            
            
		-- SELECT club, num_membre, registre, naixement, quota_tennis, quota_padel, quota_trainer, debtor;

		IF done1 = 1 THEN 
			LEAVE bucle_membres;
		END IF;

		-- Insertem les quotes opcionals de padel
        IF quota_tennis = 'Y' THEN
			SET codi_quota = 'TENIS';
            SET preu = (SELECT Price from quotes where Codi = 'TENIS');
			INSERT INTO ingressos (MemberId, ClubId, QuotaId, TempsId, Quantitat)
				SELECT num_membre, club, codi_quota, temps.tempsId, preu
					FROM temps 
					WHERE (temps.Dia IS NULL AND temps.TempsComplet > registre AND (temps.TempsComplet < debtor OR debtor IS NULL));
		END IF;
            
		-- Insertem les quotes opcionals de padel
       IF quota_padel = 'Y' THEN
			SET codi_quota = 'PADEL';
            SET preu = (SELECT Price from quotes where Codi = 'PADEL');
			INSERT INTO ingressos (MemberId, ClubId, QuotaId, TempsId, Quantitat)
				SELECT num_membre, club, codi_quota, temps.tempsId, preu 
					FROM temps 
					WHERE (temps.Dia IS NULL AND temps.TempsComplet > registre AND (temps.TempsComplet < debtor OR debtor IS NULL));
		END IF;
       
       -- Insertem les quotes opcionals de personal trainer
       IF quota_trainer = 'Y' THEN
			SET codi_quota = 'PETRA';
            SET preu = (SELECT Price from quotes where Codi = 'PETRA');
			INSERT INTO ingressos (MemberId, ClubId, QuotaId, TempsId, Quantitat)
				SELECT num_membre, club, codi_quota, temps.tempsId, preu
					FROM temps 
					WHERE (temps.Dia IS NULL AND temps.TempsComplet > registre AND (temps.TempsComplet < debtor OR debtor IS NULL));
		END IF; 
        

        -- Insertem les quotes mensuals obligatories 
		
        block2: BEGIN
        
        
		DECLARE CONTINUE HANDLER 
			FOR NOT FOUND SET done2 = 1; 
        
        
		open cursor_temps;
        
        bucle_temps: LOOP
        
			SET done2 = 0;
        
			FETCH cursor_temps
				INTO id_temps, temps_c;
            
			IF done2 = 1 THEN 
			LEAVE bucle_temps;
            END IF;
			
            
            SET edat = DATEDIFF(DATE(temps_c),naixement) DIV 365;
            
            IF edat<12 THEN SET codi_quota = 'CHILD';
			ELSEIF (12<=edat AND edat< 18) THEN SET codi_quota = 'TEEN';
			ELSEIF (18<=edat AND edat< 65) THEN SET codi_quota = 'ADUL';
			ELSE  SET codi_quota = 'PENS';
            END IF;
            
            IF (DATE(temps_c) > registre AND (DATE(temps_c) < debtor OR debtor IS NULL))
			THEN 
				SET preu = (SELECT Price from quotes where codi_quota = Codi);
                INSERT INTO ingressos (MemberId, ClubId, QuotaId, TempsId, Quantitat)
					SELECT  num_membre, club, codi_quota, id_temps, preu;
			END IF;
					
            
        END LOOP bucle_temps;
        

        END block2;
        
	CLOSE cursor_temps; 
        
	END LOOP bucle_membres;
 
	CLOSE cursor_membres;

END